package dev.shadowsoffire.apotheosis.advancements;

import net.minecraft.advancements.CriterionTriggerInstance;
import java.util.Collection;
import net.minecraft.advancements.critereon.ContextAwarePredicate;
import net.minecraft.advancements.critereon.DeserializationContext;
import com.google.gson.JsonObject;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Set;
import net.minecraft.server.PlayerAdvancements;
import java.util.Map;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.advancements.critereon.AbstractCriterionTriggerInstance;
import net.minecraft.advancements.CriterionTrigger;

public class SplittingTrigger implements CriterionTrigger<AbstractCriterionTriggerInstance>
{
    private static final ResourceLocation ID;
    Map<PlayerAdvancements, Set<CriterionTrigger.Listener<AbstractCriterionTriggerInstance>>> listeners;
    
    public SplittingTrigger() {
        this.listeners = new HashMap<PlayerAdvancements, Set<CriterionTrigger.Listener<AbstractCriterionTriggerInstance>>>();
    }
    
    public ResourceLocation m_7295_() {
        return SplittingTrigger.ID;
    }
    
    public void m_6467_(final PlayerAdvancements adv, final CriterionTrigger.Listener<AbstractCriterionTriggerInstance> listener) {
        this.listeners.computeIfAbsent(adv, a -> new HashSet()).add(listener);
    }
    
    public void m_6468_(final PlayerAdvancements adv, final CriterionTrigger.Listener<AbstractCriterionTriggerInstance> listener) {
        this.listeners.computeIfAbsent(adv, a -> new HashSet()).remove(listener);
    }
    
    public void m_5656_(final PlayerAdvancements adv) {
        this.listeners.remove(adv);
    }
    
    public AbstractCriterionTriggerInstance createInstance(final JsonObject json, final DeserializationContext parser) {
        return new AbstractCriterionTriggerInstance(SplittingTrigger.ID, ContextAwarePredicate.f_285567_) {};
    }
    
    public void trigger(final PlayerAdvancements adv) {
        if (this.listeners.containsKey(adv)) {
            new HashSet(this.listeners.get(adv)).forEach(t -> t.m_13686_(adv));
        }
    }
    
    static {
        ID = new ResourceLocation("apotheosis", "splitting");
    }
}
